/*
** list_sort.c for list in /u/a1/deleda_c/rendu/piscine/j6/list
**
** Made by charles-alban deledalle
** Login   <deleda_c@epita.fr>
**
** Started on  Sat Sep 17 01:06:01 2005 charles-alban deledalle
** Last update Sat Sep 17 03:09:39 2005 charles-alban deledalle
*/

#include <stdlib.h>
#include "s_list.h"

static void	swap_ptr(void **a, void **b)
{
  void		*c;

  c = *a;
  *a = *b;
  *b = c;
}

void		list_sort(struct s_list **list, t_cmp_func cmp_func)
{
  struct s_list	*der;
  struct s_list	*i;
  struct s_list	*j;
  int		modif = 1;

  der = NULL;
  for (i = *list; i && modif; i = i->next)
    {
      modif = 0;
      for (j = *list; j->next != der; j = j->next)
	if (cmp_func(j->data, j->next->data) > 0)
	  {
	    swap_ptr(&(j->data), &(j->next->data));
	    modif = 1;
	  }
      der = j;
    }
}
